public class CaRunner implements Runnable
{
  private HexagonalCell hexagonalCell;
  private HexGrid hexGrid;
  
  public CaRunner(HexagonalCell hexagonalCell, HexGrid hexGrid)
  {
    this.hexagonalCell = hexagonalCell;
    this.hexGrid = hexGrid;
  }

  public void run()
  {
    try
    {
      while (hexagonalCell.isRunning())
      { 
        hexagonalCell.step();
        hexGrid.repaint();
        int delay = hexagonalCell.getDelay();
        if (delay > 0)
          Thread.sleep(delay);
      }
    }
    catch (InterruptedException e)
    {
    }
  }
}
