import java.awt.*;
import javax.swing.*;
import java.io.*;

class FrankBussRule extends Rule
{
  public FrankBussRule(JFrame mainFrame, HexagonalCell hexagonalCell)
  {
    super(mainFrame, hexagonalCell);
    this.mainFrame = mainFrame;
    this.hexagonalCell = hexagonalCell;
  }

  public void setNewRule()
  {
  }

  public void setOptions()
  {
  }

  public void setDefault()
  {
  }

  public void changeRule()
  {
  }

  public void writeRule(PrintWriter pw)
  {
    pw.println("#Rule = Frank Buss Rule");
  }

  public void readRule(BufferedReader br)
  {
  }

  public int step(int column, int row)
  {
    int neighbors[] = new int[6];
    if ((row % 2) == 0)
    {
      neighbors[0] = hexagonalCell.getCell(column - 1, row - 1);
      neighbors[1] = hexagonalCell.getCell(column    , row - 1);
      neighbors[2] = hexagonalCell.getCell(column - 1, row + 1);
      neighbors[3] = hexagonalCell.getCell(column    , row + 1);
    }
    else
    {
      neighbors[0] = hexagonalCell.getCell(column    , row - 1);
      neighbors[1] = hexagonalCell.getCell(column + 1, row - 1);
      neighbors[2] = hexagonalCell.getCell(column    , row + 1);
      neighbors[3] = hexagonalCell.getCell(column + 1, row + 1);
    }
    neighbors[4] = hexagonalCell.getCell(column - 1, row);
    neighbors[5] = hexagonalCell.getCell(column + 1, row);
    int sum1 = 0;
    int sum2 = 0;
    for (int i = 0; i < 6; i++)
      if (neighbors[i] == 1)
        sum1++;
      else if (neighbors[i] == 2)
        sum2++;
    if ((sum1 == 0) && (sum2 == 1) && (hexagonalCell.getCell(column, row) == 0))
      return 2;
    else if ((sum1 == 1) && (sum2 == 1))
      return 1;
    else if (sum2 == 2)
      return 1;
    else if (sum2 == 3)
      return 2;
    return 0;
  }

  public int getNoStates()
  {
    return 3;
  }
}
