import java.awt.*;
import javax.swing.*;

public class StatusBar extends JPanel
{
  String cycle;
  String population;
  String worldSize;
  String gridSize;
  String gridOffset;
  String gridPosition;
  String tablePosition;
  String state;
  String speedDelay;
  String patternName;
  JLabel statusBarText;
  
  public StatusBar(int columns, int rows)
  {
    statusBarText = new JLabel();
    setCycle(0);
    setPopulation(0);
    setWorldSize(columns, rows);
    gridSize = "";
    gridOffset = "";
    gridPosition = "";
    tablePosition = "";
    state = "";
    speedDelay = "";
    patternName = "";
    setLayout(new FlowLayout(FlowLayout.LEFT));
    add(statusBarText);
  }

  private void setText()
  {
    statusBarText.setText(cycle + population + worldSize + gridSize + gridOffset + gridPosition +
                          tablePosition + state + speedDelay + patternName);
  }


  public void setCycle(int cycle)
  {
    this.cycle = "Cycle " + cycle;
    setText();
  }

  public void setPopulation(int population)
  {
    this.population = "  Population " + population;
    setText();
  }

  public void removePopulation()
  {
    population = "";
    setText();
  }
  public void setWorldSize(int columns, int rows)
  {
    worldSize = "  World " + columns + "x" + rows;
    setText();
  }

  public void setGridSize(int columns, int rows)
  {
    gridSize = "  Display " + columns + "x" + rows;
    setText();
  }

  public void setGridOffset(int columns, int rows)
  {
    gridOffset = "  Offset " + columns + "x" + rows;
    setText();
  }

  public void setPosition(int worldColumns, int worldRows, int gridColumns, int gridRows)
  {
    gridPosition = "  Position World " + worldColumns + "x" + worldRows + " Display " + gridColumns + "x" + gridRows;
    setText();
  }

  public void removePosition()
  {
    gridPosition = "";
    setText();
  }

  public void setTablePosition(int columns, int rows)
  {
    tablePosition = " Table Position " + columns + "x" + rows;
  }

  public void removeTablePosition()
  {
    tablePosition = "";
    setText();
  }

  public void setState(int state)
  {
    this.state = "  State " + state;
    setText();
  }

  public void removeState()
  {
    state = "";
    setText();
  }

  public void setSpeedDelay(int delay)
  {
    speedDelay = "  Delay " + delay;
    setText();
  }

  public void removeSpeedDelay()
  {
    speedDelay = "";
    setText();
  }

  public void setPatternName(String fileName)
  {
    patternName = "  Pattern " + fileName;
    setText();
  }

  public void removePatternName()
  {
    patternName = "";
    setText();
  }
}
