import java.util.*;
import java.io.*;

public class RuleTable3Converter
{
  private BufferedReader in;
  private PrintWriter out;
  private ArrayList<String> list;

  public static void main(String[] args)
  {
    try
    {
      File pathName = new File(args[0]);
      String[] fileNames = pathName.list();
      RuleTable3Converter converter = new RuleTable3Converter();
      for (int i = 0; i < fileNames.length; i++)
      {  
        File in = new File(pathName.getPath(), fileNames[i]);
        if (in.isDirectory())
          main(new String[] {in.getPath()});
        else if (in.getCanonicalPath().endsWith(".sqc"))
        {
          String s = in.getCanonicalPath();
          System.out.println(s);
          converter.setBufferedReader(new BufferedReader(new FileReader(in)));
          converter.readFile();
          in.delete();
          File out = new File(pathName.getPath(), fileNames[i]);
          if (! out.exists())
            out.createNewFile();
          converter.setPrintWriter(new PrintWriter(new BufferedWriter(new FileWriter(out))));
          converter.writeFile();
        }
      }
    }
    catch(IOException e)
    {  
      e.printStackTrace();
    }
  }

  public RuleTable3Converter()
  {
  }

  public void setBufferedReader(BufferedReader br)
  {
    in = br;
  }

  public void setPrintWriter(PrintWriter pw)
  {
    out = pw;
  }

  public void readFile()
  {
    try
    {
      String line;
      list = new ArrayList<String>();
      while ((line = in.readLine()) != null)
      {
        list.add(line);
      }
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
  }

  public void writeFile()
  {
    out.println("#Rule = Rule Table 3");
    out.println("#States = 4");
    out.println("#Wall = yes");
    out.println("#Table = 15");
    out.println("#SW 0,1,2,0");
    for (int i = 3; i < list.size(); i++)
      out.println(list.get(i));
		out.close();
  }
}
