import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

class HexGridSpinner extends JLabel implements MouseListener
{
  private int value;
  private int minimum;
  private int maximum;

  public HexGridSpinner(int height, int width, int value, int minimum, int maximum)
  {
    this.value = value;
    this.minimum = minimum;
    this.maximum = maximum;
    addMouseListener(this);
    setPreferredSize(new Dimension(height, width));
    setFont(new Font("Monospaced", Font.PLAIN, 14));
    setHorizontalAlignment(CENTER);
    setBorder(BorderFactory.createEtchedBorder());
    setSpinnerText(value);
  }

  private void setSpinnerText(int value)
  {
    if (isEnabled())
      setText(Integer.toHexString(value));
    else
      setText("");
  }

  public void setSpinnerEnabled(boolean enabled)
  {
    setEnabled(enabled);
    setSpinnerText(value);
  }

  public int getValue()
  {
    return value;
  }

  public void setValue(int value)
  {
    this.value = value;
    setSpinnerText(value);
  }

  public void mousePressed(MouseEvent e)
  {
    if (e.isShiftDown())
    {
      if (value == minimum)
      {
        value = maximum;
        setSpinnerText(maximum);
      }
      else
        setSpinnerText(--value);
    }
    else
    {
      if (value == maximum)
      {
        value = minimum;
        setSpinnerText(minimum);
      }
      else
        setSpinnerText(++value);
    }
  }

  public void mouseExited(MouseEvent e) {}
  public void mouseClicked(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
}
