import java.net.*;
import java.io.*;

class Patterns
{
  private String patternDirectory;
  private String[] patternFileNames;
  private int numberPatterns;
  private int currentPattern;

  public Patterns(String patternDirectory, String patternName)
  {
    this.patternDirectory = patternDirectory;
    String s[] = new File(patternDirectory).list();
    numberPatterns = 0;
    for (int i = 0; i < s.length; i++)
      if (s[i].endsWith(".sqc"))
        numberPatterns++;
    if (numberPatterns > 0)
    {
      patternFileNames = new String[numberPatterns];
      int j = 0;
      for (int i = 0; i < s.length; i++)
        if (s[i].endsWith(".sqc"))
          patternFileNames[j++] = s[i];
      currentPattern = 0;
      for (int i = 0; i < numberPatterns; i++)
        if (patternFileNames[i].equals(patternName))
          currentPattern = i;
    }
  }

  public Patterns(String url)
  {
    patternDirectory = url.substring(0, url.lastIndexOf('/'));
    try
    {
	    URL rulePatterns = new URL(patternDirectory);
	    BufferedReader in = new BufferedReader(new InputStreamReader(rulePatterns.openStream()));
      String line;
      numberPatterns = 0;
	    while ((line = in.readLine()) != null)
      {
        if ((line.indexOf("href=") > 0) && (line.indexOf(".sqc") > 0))
          numberPatterns++;
      }
	    in.close();
      if (numberPatterns > 0)
      {
        patternFileNames = new String[numberPatterns];
        int i = 0;
	      in = new BufferedReader(new InputStreamReader(rulePatterns.openStream()));
	      while ((line = in.readLine()) != null)
        {
          if ((line.indexOf("href=") > 0) && (line.indexOf(".sqc") > 0))
            patternFileNames[i++] = line.substring(line.indexOf("href=") + 6, line.indexOf(".sqc") + 4);
        }
	      in.close();
        currentPattern = 0;
        for (i = 0; i < numberPatterns; i++)
          if (patternFileNames[i].equals(url.substring(url.lastIndexOf('/') + 1)))
            currentPattern = i;
      }
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
  }

  public String getNext()
  {
    if (++currentPattern == patternFileNames.length)
      currentPattern = 0;
    return patternDirectory + "/" + patternFileNames[currentPattern];
  }

  public String getPrevious()
  {
    if (--currentPattern < 0)
      currentPattern = patternFileNames.length - 1;
    return patternDirectory + "/" + patternFileNames[currentPattern];
  }

  public String getCurrent()
  {
    return patternDirectory + "/" + patternFileNames[currentPattern];
  }

  public int getNumberPatterns()
  {
    return numberPatterns;
  }

  public String getDirectory()
  {
    return patternDirectory;
  }
}
