public class CaRunner implements Runnable
{
  private TriangularCell triangularCell;
  private TriGrid triGrid;
  
  public CaRunner(TriangularCell triangularCell, TriGrid triGrid)
  {
    this.triangularCell = triangularCell;
    this.triGrid = triGrid;
  }

  public void run()
  {
    try
    {
      while (triangularCell.isRunning())
      { 
        triangularCell.step();
        triGrid.repaint();
        int delay = triangularCell.getDelay();
        if (delay > 0)
          Thread.sleep(delay);
      }
    }
    catch (InterruptedException e)
    {
    }
  }
}
